/* a little program to convert colormaps */
#include <stdio.h>

char l[4096];
int p;

int get_line(FILE *f)
{
  int c;
  if (feof(f)) return 1;
  p = 0;
  while (1) {
    c = fgetc(f);
    if (c == EOF || c == '\n') break;
    l[p] = c;
    p++;
    if (p == 4096) return 1;
  }
  l[p] = 0;
  return 0;
}

int main(int n, char **v)
{
  FILE *in;
  FILE *out;
  float f0, f1, f2, f3, f4;
  int i;
  if (n != 3) { printf("gimme <in> <out>\n"); return 1; }
  in = fopen(v[1], "rb");
  out = fopen(v[2], "wb");
  if (get_line(in)) return 1;
  if (get_line(in)) return 1;
  if (sscanf(l, "%d", &i) == 1 && i == 1) {
    fprintf(out, "mapsize 12\n");
    for (i = 0; i < 12; i++) {
      if (get_line(in)) return 1;
      if (sscanf(l, "( %g , %g , %g , %g )", &f0,&f1,&f2,&f3) != 4) return 1;
      fprintf(out, "cell %d %g %g %g\n", i, f0, f1, f2);
    }
    fprintf(out, "dBmin -120\n");
    fprintf(out, "dBmax 0\n");
    return 0;
  }
  fprintf(out, "mapsize 4096\n");
  while (!get_line(in)) {
    if (sscanf(l, "%g ( %g , %g , %g , %g )",
        &f0, &f1, &f2, &f3, &f4) != 5) continue;
    fprintf(out, "colorb %g %g %g %g\n", f0, f1, f2, f3);
  }
  fprintf(out, "buildmap\n");
  fprintf(out, "dBmin -120\n");
  fprintf(out, "dBmax 0\n");
  fclose(in);
  fclose(out);
  return 0;
}
