/* FFT algorithm - from the book DSP by Proakis & Manolakis
 * radix 2 stuff
 * public domain
 * surely slower than death, who gives a shit...
 * sed@free.fr
 */

#ifndef _FFT_H_
#define _FFT_H_

#ifdef FFTW
#include <fftw3.h>
typedef fftwf_complex complex;
typedef float fft_in;
#else
typedef struct {
  double re;
  double im;
} complex;
typedef double fft_in;
#endif

typedef struct {
  int n;
#ifdef FFTW
  fftwf_plan plan;
#else
  int logn;
  complex *wn;
  int *bit_reverse;
#endif
} fft;

#ifdef FFTW
void fft_memalloc(float **, fftwf_complex **, int);
void fft_memfree(float *, fftwf_complex *);
int open_fft(fft *, int, float *, fftwf_complex *);
#else
int open_fft(fft *, int);
#endif
void close_fft(fft *);

void fft_double(fft *, fft_in *, complex *);
void ifft_double(fft *, complex *, complex *);

#endif /* _FFT_H_ */
