/* generated by gtkcooker (http://sed.free.fr/gtkcooker) */

#include <gtk/gtk.h>
#include "gui_colors.h"

#include <stdio.h>



#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#include "colors.h"
#include "defs.h"
#include "gui.h"

static void load_colormap_gui(gui_colormap *);
static void raw_activated(GtkTreeView *u1, GtkTreePath *u2,
                          GtkTreeViewColumn *u3, gpointer _this)
{
  load_colormap_gui(_this);
}

static void setup_box(gui_colormap *this)
{
  GtkListStore *store;
  GtkWidget *tree;
  GtkCellRenderer *render1, *render2;
  GtkTreeViewColumn *col1, *col2;
  GtkWidget *treebox;

  store = gtk_list_store_new(3, G_TYPE_OBJECT, G_TYPE_STRING, G_TYPE_STRING);

  tree = gtk_tree_view_new_with_model(GTK_TREE_MODEL(store));

  render1 = gtk_cell_renderer_pixbuf_new();
  render2 = gtk_cell_renderer_text_new();

  col1 = gtk_tree_view_column_new_with_attributes("Colormap", render1,
             "pixbuf", 0, NULL);
  col2 = gtk_tree_view_column_new_with_attributes("Filename", render2,
             "text", 1, NULL);

  gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col1);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col2);

  treebox = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(treebox),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(treebox),
    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(treebox),
    GTK_CORNER_TOP_LEFT);
  gtk_container_add(GTK_CONTAINER(treebox), tree);
  gtk_container_add(GTK_CONTAINER(this->b), treebox);

  g_signal_connect(tree, "row_activated", G_CALLBACK(raw_activated), this);

  this->store = store;
  this->tree = tree;
}

static void populate_error(gui_colormap *this, const char *l)
{
  GtkTreeIter iter;
  GdkPixbuf *pixbuf;
  unsigned char *colors;
  int i;

  colors = malloc(200*10*3); if (!colors) { printf("oom\n"); exit(1); }
  for (i = 0 ; i < 200*10; i++) {
    colors[i*3] = 255; colors[i*3+1] = 0; colors[i*3+2] = 0;
  }
  for (i = 0; i < 20; i++) {
    colors[(4*200+90+i)*3] = 255;
    colors[(4*200+90+i)*3+1] = 255;
    colors[(4*200+90+i)*3+2] = 255;
    colors[(5*200+90+i)*3] = 255;
    colors[(5*200+90+i)*3+1] = 255;
    colors[(5*200+90+i)*3+2] = 255;
  }
  pixbuf = gdk_pixbuf_new_from_data(colors, GDK_COLORSPACE_RGB, FALSE, 8,
                                    200, 10, 200*3,
                                    (GdkPixbufDestroyNotify)free, colors);
  gtk_list_store_append(this->store, &iter);
  gtk_list_store_set(this->store, &iter, 0, pixbuf, 1, l, 2, "", -1);
}

static void populate_file(gui_colormap *this, const char *filename,
                          const char *name)
{
  GtkTreeIter iter;
  GdkPixbuf *pixbuf;
  unsigned char *colors;
  colormap m;
  int i, j;

  if (load_colormap(&m, filename, 0)) return populate_error(this, name);

  colors = malloc(200*10*3); if (!colors) { printf("oom\n"); exit(1); }
  for (i = 0; i < 200; i++) {
    unsigned char *rgb = get_color(&m, R3(i, 0, 199, m.mindB, m.maxdB));
    for (j = 0; j < 10; j++) {
      colors[(j*200+i)*3] = rgb[0];
      colors[(j*200+i)*3+1] = rgb[1];
      colors[(j*200+i)*3+2] = rgb[2];
    }
  }
  pixbuf = gdk_pixbuf_new_from_data(colors, GDK_COLORSPACE_RGB, FALSE, 8,
                                    200, 10, 200*3,
                                    (GdkPixbufDestroyNotify)free, colors);
  gtk_list_store_append(this->store, &iter);
  gtk_list_store_set(this->store, &iter, 0, pixbuf, 1, name, 2, filename, -1);

  free_colormap(&m);
}

typedef struct {
  char **names;
  int size;
  int maxsize;
} file_list;
static void add_filename(file_list *l, const char *n)
{
  int i;
  char *d = strdup(n);
  if (!d) { printf("oom\n"); exit(1); }
  if (l->size == l->maxsize) {
    l->maxsize += 64;
    if (!l->size)
      l->names = malloc(sizeof(const char *) * l->maxsize);
    else
      l->names = realloc(l->names, sizeof(const char *) * l->maxsize);
    if (!l->names) { printf("oom\n"); exit(1); }
  }
  l->names[l->size] = d;
  i = l->size;
  l->size++;
  while (i) {
    char *z;
    if (strcmp(l->names[i-1], l->names[i]) <= 0) break;
    z = l->names[i];
    l->names[i] = l->names[i-1];
    l->names[i-1] = z;
    i--;
  }
}
static void free_file_list(file_list *l)
{
  int i;
  for (i = 0; i < l->size; i++) free(l->names[i]);
  if (l->maxsize) free(l->names);
}

static void populate_box(gui_colormap *this)
{
  const char *dirname = this->curdir;
  DIR *d = opendir(dirname);
  struct dirent *dir;
  char name[FILENAME_MAX+1];
  int len = strlen(dirname);
  file_list l;
  int i;

  memset(&l, 0, sizeof(file_list));

  if (!d) { populate_error(this, "error"); return; }
  while (1) {
    dir = readdir(d);
    if (!dir) break;
    if (!strcmp(dir->d_name, ".")) continue;
    if (!strcmp(dir->d_name, "..")) continue;
    add_filename(&l, dir->d_name);
  }
  closedir(d);

  for (i = 0; i < l.size; i++) {
    if (strlen(l.names[i]) + len + 1 > FILENAME_MAX) {
      populate_error(this, l.names[i]);
      continue;
    }
    sprintf(name, "%s/%s", dirname, l.names[i]);
    populate_file(this, name, l.names[i]);
  }
  free_file_list(&l);
}

static void empty_box(gui_colormap *this)
{
  gtk_list_store_clear(this->store);
}

static void close_colormap_gui(gui_colormap *this)
{
  gtk_list_store_clear(this->store);
  g_object_unref(this->store);
  gtk_widget_destroy(this->w);
  gtk_widget_destroy(this->file_choose);
  this->shown = 0;
  this->file_choose_shown = 0;
}

static void load_colormap_gui(gui_colormap *this)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  GtkTreeModel *model;
  char *filename;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(this->tree));
  if (!gtk_tree_selection_get_selected(sel, &model, &iter)) return;
  gtk_tree_model_get(model, &iter, 2, &filename, -1);

  if (filename[0] == 0) { g_free(filename); return; }

  gui_load_colormap(this->mainwin, filename);
  close_colormap_gui(this);

  g_free(filename);
}

static void show_file_choose(gui_colormap *this)
{
  if (this->file_choose_shown) return;
  this->file_choose_shown = 1;
  gtk_widget_show_all(this->file_choose);
}

static void hide_file_choose(gui_colormap *this)
{
  if (!this->file_choose_shown) return;
  this->file_choose_shown = 0;
  gtk_widget_hide(this->file_choose);
}

static int isdir(const char *f)
{
  struct stat b;
  if (stat(f, &b)) return 0;
  return S_ISDIR(b.st_mode);
}


static gboolean _1(GtkWidget *_widget, GdkEvent *_event, gui_colormap *this)
{
{close_colormap_gui(this);}
  return TRUE;
}

static void _3(GtkButton *_widget, gui_colormap *this)
{
  {show_file_choose(this);}
}

static void _5(GtkButton *_widget, gui_colormap *this)
{
  {load_colormap_gui(this);}
}

static void _7(GtkButton *_widget, gui_colormap *this)
{
  {close_colormap_gui(this);}
}

static void _8(GtkButton *_widget, gui_colormap *this)
{
  const char *filename;
  GtkWidget *_file = (GtkWidget*)_widget;
  while (GTK_WIDGET_TYPE(_file) != GTK_TYPE_FILE_SELECTION)
    _file = gtk_widget_get_parent(_file);
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(_file));
  {
    if (strlen(filename) > FILENAME_MAX) return;
    strcpy(this->curdir, filename);
    if (!isdir(this->curdir)) {
      char *s = this->curdir + strlen(this->curdir);
      while (s != this->curdir) { s--; if (*s == '/') { *s = 0; break; } }
    }
    gtk_label_set_text(this->dir, this->curdir);
    hide_file_choose(this);
    empty_box(this);
    populate_box(this);
  }
}

static void _9(GtkButton *_widget, gui_colormap *this)
{
  GtkWidget *_file = (GtkWidget*)_widget;
  while (GTK_WIDGET_TYPE(_file) != GTK_TYPE_FILE_SELECTION)
    _file = gtk_widget_get_parent(_file);
  {
    hide_file_choose(this);
  }
}

/* returns -1 on error, 0 if everything is fine */
int init_gui_colormap(gui_colormap *this, const char *init_dir, struct mainwin *w)
{
  GtkWidget *_0;
  GtkWidget *choose;
  GtkWidget *_2;
  GtkWidget *okb;
  GtkWidget *_4;
  GtkWidget *cancelb;
  GtkWidget *_6;
  GtkWidget *ocb;
  GtkWidget *_10;
  GtkWidget *_11;
  GtkWidget *_12;

  { this->mainwin = w; this->file_choose_shown = 0; }

  this->w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request((GtkWidget *)this->w, 500, 400);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->w),
        (GtkWidget *)this->w, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  this->b = gtk_vbox_new(FALSE, 0);
  this->dir = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->dir), "");
  gtk_misc_set_alignment(GTK_MISC(this->dir), 0.000000, 0.500000);
  choose = gtk_button_new();
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "_Browse");
  okb = gtk_button_new();
  _4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_4), "_OK");
  cancelb = gtk_button_new();
  _6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_6), "_Cancel");
  ocb = gtk_vbox_new(FALSE, 0);
  this->file_choose = gtk_file_selection_new("Select directory");
  _10 = gtk_hbox_new(FALSE, 0);
  _11 = gtk_hbox_new(FALSE, 0);
  _12 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->w), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_11, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_12, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(choose), (GtkWidget *)_2);
  gtk_container_add(GTK_CONTAINER(okb), (GtkWidget *)_4);
  gtk_container_add(GTK_CONTAINER(cancelb), (GtkWidget *)_6);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)this->dir, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)choose, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_11), (GtkWidget *)this->b, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_12), (GtkWidget *)ocb, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_12), (GtkWidget *)okb, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_12), (GtkWidget *)cancelb, FALSE, FALSE, 0);


  this->w_delete = g_signal_connect(this->w, "delete-event", G_CALLBACK(_1), this);

  this->choose_clicked = g_signal_connect(choose, "clicked", G_CALLBACK(_3), this);

  this->okb_clicked = g_signal_connect(okb, "clicked", G_CALLBACK(_5), this);

  this->cancelb_clicked = g_signal_connect(cancelb, "clicked", G_CALLBACK(_7), this);

  this->file_choose_ok = g_signal_connect(GTK_FILE_SELECTION(this->file_choose)->ok_button, "clicked", G_CALLBACK(_8), this);
  this->file_choose_cancel = g_signal_connect(GTK_FILE_SELECTION(this->file_choose)->cancel_button, "clicked", G_CALLBACK(_9), this);

  {
    gtk_window_set_title(this->w, "spectrojack colormap selection");
    setup_box(this);
    populate_box(this);
    gtk_label_set_text(this->dir, this->curdir);
  }

  return 0;
}

