#include "jackend.h"

#include <jack/jack.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#define R do{printf("%s:%d:err\n",__FILE__,__LINE__);exit(1);}while(0)

static int process(jack_nframes_t n, void *_j)
{
  jack_stuff                   *j = _j;
  jack_default_audio_sample_t  *in;
  float                        *out;
  int                          i;
  uint32_t                     nn;

  if (j->paused) return 0;

  in = jack_port_get_buffer(j->port, n);
  out = j->buffer;

  if (n > j->buffer_size) R;

  for (i = 0; i < n; i++) out[i] = in[i];

  nn = n;
  if (write(j->_jackfd, &nn, 4) != 4) R;

  return 0;
}

static void jshutdown(void *_j)
{
  printf("jack shutdown\n");
  exit(1);
}

void init_jack(jack_stuff *j)
{
  jack_client_t *client;
  jack_status_t status;
  jack_port_t   *port;
  int           i;
  int           p[2];
  long          f;

  if (pipe(p)) R;
  f = fcntl(p[0], F_GETFL); if (f == -1) R;
  f |= O_NONBLOCK;
  if (fcntl(p[0], F_SETFL, f) == -1) R;
  f = fcntl(p[1], F_GETFL); if (f == -1) R;
  f |= O_NONBLOCK;
  if (fcntl(p[1], F_SETFL, f) == -1) R;

  j->jackfd = p[0];
  j->_jackfd = p[1];

  j->paused = 0;

  client = jack_client_open("spectrojack", JackNoStartServer, &status);
  if (!client) R;
  jack_set_process_callback(client, process, j);
  jack_on_shutdown(client, jshutdown, j);
  port = jack_port_register(client, "spectrojack_in", JACK_DEFAULT_AUDIO_TYPE,
                            JackPortIsInput, 0);
  if (!port) R;
  j->port = port;
  j->sample_rate = jack_get_sample_rate(client);
  j->buffer_size = 4096;
  j->buffer = malloc(4096 * sizeof(float)); if (!j->buffer) R;
  for (i = 0; i < 4096; i++) j->buffer[i] = 0;
  printf("sample_rate: %lu\n", j->sample_rate);
  if (jack_activate(client)) R;
}
