#ifndef _POWER_BUFFER_H_
#define _POWER_BUFFER_H_

#include "fft.h"
#include "fft_window.h"

typedef struct power_buffer {
  void (*buffer_new_line)(void *);
  void *bnl_data;
  int width;

  float *power;    /* width * (fft_size/2+1) */
  int line;
  fft_in *buffer;  /* fft_size */
  int processed;
  int to_process;
  int overlap_samples;
  float overlap;
  float buf_min;
  float buf_max;
  float mindB_stats;
  float maxdB_stats;

  complex *fft_buffer;
  fft fft;
  float _10_log10_nn;
  fft_window window;
} power_buffer;

void power_buffer_init(power_buffer *, int, int, void (*)(void *), void *, int);
void power_buffer_feed(power_buffer *, float *, int);
void power_buffer_resize(power_buffer *, int, int);
void power_buffer_set_fft_size(power_buffer *, int);
float *power_buffer_get_line(power_buffer *, int);
void power_buffer_set_to_process(power_buffer *, int);
void power_buffer_set_overlap(power_buffer *, float);
void power_buffer_close(power_buffer *);

#endif /* _POWER_BUFFER_H_ */
